#! /bin/sh
# TFTPD on the fly file generator 
# (C) 2011 INRIA
# (C) 2004-2005 ICATIS

EXITSTATUS=0

FILE="$1" 


# The Mac address provides by the isc-dhcp server looks like this : 0:0:0...
# instead of 00:00:00...  we fixe the format here.
TMPFILE="`echo ${FILE} |sed -e "s/:/ /g"|sed -e "s/-/ /g"`"
FILE=""
for addr in $TMPFILE; do
	if [ ${#addr} -eq 1 ]; then
		addr="0$addr";
	fi 
	if [ "$FILE" = "" ]; then
		FILE="$addr"
	else
		FILE="$FILE:$addr"
	fi
done

# In the CM database, mac address are recorded with the separator "-" and not ":" 
PXEFILE="`echo ${FILE} |sed -e "s/:/-/g"`"
HTTPDIR=/var/www
BOOTDIR=bootdirectory
STOREDIR=$BOOTDIR/images

if [ "$FILE" = "" ] || [ "$PXEFILE" = "" ]; then
	BOOTMODETYPE=local
else
	# We need to get some extra information from a web server to generate the file
	# The web server ($URL) gets $ETHER as input
	URL='http://127.0.0.1/cm/engine/get_pxeconf.php?mac='

	# $URL output set shell variables
	eval `wget -q -O- "${URL}${PXEFILE}" | grep "^[[:alnum:]_]\+="`
fi

# If static bootmode type
if [ "$BOOTMODETYPE" = "RawPXEConfig" ] && \
	[ -n "$CONFIGFILE" ] && \
	[ -r "$CONFIGFILE" ] ; then
cat << EOF > $HTTPDIR/$BOOTDIR/$FILE
#RawPXE boot, see the /srv/tftp/PXEClient/pxelinux.cfg directory
EOF
		cp $CONFIGFILE /srv/tftp/PXEClient/pxelinux.cfg/01-$PXEFILE 
		exit 0
fi

# If computemode bootmode type...

if [ "$BOOTMODETYPE" = "ComputeMode" ] && \
	[ -n "$KERNEL" ] && [ -r "$HTTPDIR/$STOREDIR/$KERNEL" ] && \
	[ -n "$INITRD" ] && [ -r "$HTTPDIR/$STOREDIR/$INITRD" ] && \
	[ -n "$CMDLINE" ]; then

cat << EOF > $HTTPDIR/$BOOTDIR/$FILE
#!ipxe
kernel http://\${next-server}/bootdirectory/images/$KERNEL initrd=$INITRD `echo $CMDLINE | sed 's/IP=append//g'`
initrd http://\${next-server}/bootdirectory/images/$INITRD
boot
EOF
	exit 1
fi

# Else: local boot
cat <<EOF > $HTTPDIR/$BOOTDIR/$FILE
#Local boot, nothing to do.
EOF
exit 2
